//+------------------------------------------------------------------+
//|		                                                    		Nets.h |
//|					                         Copyright 2009,   |
//|                                              profy.mql@gmail.com |
//| 10.10							                                               |
//+------------------------------------------------------------------+
#property copyright "Copyright 2009,  "
#property link      "mailto: profy.mql@gmail.com"
#property version   "1.00"

#define KEY_RIGHT          39

#define MaxIn	40
input int MaxPat=9000;
input int TP=20;

#include <..\..\..\..\!Neyruto\ChartObjects\ChartObjectsTxtControls.mqh>
#include <..\..\..\..\!Neyruto\ChartObjects\ChartObjectsArrows.mqh>
#include <..\..\..\..\!Neyruto\NeuroNet.mqh>

CChartObjectButton btnStep, btnWalk; //  
CChartObjectArrow aout[]; //MaxPat+1

double ma[1], dma[MaxIn]; // 
MqlRates rates[]; //  
MqlRates M1[]; //  

double InArr[MaxIn];
datetime time[]; //MaxPat+1
int p[MaxIn], hma[MaxIn];  //   
int cPattern, Loop; //    

CNeuroNet Net; //  

//----------------------------------------------------------------- OnInit
int OnInit()
{
	p[0]=2; p[1]=5; p[2]=8; p[3]=11; p[4]=14; p[5]=17; p[6]=21; p[7]=25; 
	p[8]=29; p[9]=33; p[10]=38; p[11]=43; p[12]=48; p[13]=53; p[14]=60; p[15]=67; 
	p[16]=75; p[17]=82; p[18]=91; p[19]=101; p[20]=112; p[21]=124; p[22]=137; p[23]=151; 
	p[24]=165; p[25]=182; p[26]=200; p[27]=220; p[28]=240; p[29]=265; p[30]=295; p[31]=325; 
	p[32]=359; p[33]=396; p[34]=434; p[35]=474; p[36]=518; p[37]=565; p[38]=615; p[39]=670; 
	
	//   
	btnStep.Create(0, "Step", 0, 3, 110, 10, 30, 20, ">");
	btnStep.Color(Black); btnStep.BackColor(Orange);
	btnWalk.Create(0, "Walk", 0, 3, 110, 40, 30, 20, ">>");
	btnWalk.Color(Black); btnWalk.BackColor(Orange);
	ChartRedraw();

	InitNet(Symbol(), Period()); //   
	return(0);
}
//----------------------------------------------------------------- InitNet
void InitNet(string smb, ENUM_TIMEFRAMES tf)
{
	int nIN=8, nOUT=1, L, i, pat, nm;
	string name, st="";
	double max, min;
	int Pnt=1;
	if (Digits()==5) Pnt=10;
	ArrayResize(aout, MaxPat+1);
	ArrayResize(time, MaxPat+1);
	
	L=0; Net.nNeuron[L]=nIN;	//     // in[]
	L++; Net.nNeuron[L]=nIN+5;//    
	L++; Net.nNeuron[L]=nOUT;	//      (   Target)
	L++; Net.nNeuron[L]=nOUT;	//   // out[]
	Net.Init(MaxPat, L, 10000, 1e-8, 0.2, 0.2); //  

	//  /
	for (i=0; i<MaxIn; i++) 
		hma[i]=iMA(smb, tf, p[i], 0, MODE_EMA, PRICE_MEDIAN); //  
	
	ArraySetAsSeries(rates, true); ArraySetAsSeries(M1, true); 
	CopyRates(smb, tf, 0, MaxPat+1, rates); //     
	nm=CopyRates(smb, PERIOD_M1, 0, Bars(smb, PERIOD_M1), M1); //   
	
	for (pat=0; pat<MaxPat; pat++)
	{
		//  
		for (i=0; i<nIN; i++)
		{
			L=CopyBuffer(hma[i], MAIN_LINE, pat+1, 1, ma); //  
			Net.in[i][pat]=((rates[pat+1].high+rates[pat+1].low)/2-ma[0]); //       
		}
		//  
		int tp=-2, j, k;
		for(i=0; i<nm; i++) //      ,     
		{
			if (M1[i].time<=rates[pat].time) //   
			{
				tp=-1; 
				for (j=i; j>=0; j--) //      
				{
					if (M1[j].low<=M1[i].open-TP*Pnt*Point()) { tp=OP_SELL; break; } //   
					else if (M1[j].high>=M1[i].open+TP*Pnt*Point()) { tp=OP_BUY; break; } //   
				}
				k=0; min=10; max=-1; if (j<0) j=0;
				for (k=i; k>=j; k--) //   
				{
					if (M1[k].low<min) min=M1[k].low;
					if (M1[k].high>max) max=M1[k].high;
				}
			}
			if (tp>-2) break; 
		}
		Net.out[0][pat]=0.5;  //      
		if (i>=0 && i<nm) { min=M1[i].open-min; max=max-M1[i].open; }
		
		if (tp==OP_BUY) //    
		{ 	
			if (min==0) Net.out[0][pat]=1; 
			else if (max/min>=2) Net.out[0][pat]=1;
			else if (max/min>=1.5) Net.out[0][pat]=0.75; 
		}
		else if (tp==OP_SELL) //    
		{
			if (max==0) Net.out[0][pat]=1e-10;
			else if (min/max>=2) Net.out[0][pat]=1e-10;
			else if (min/max>=1.5) Net.out[0][pat]=0.25;
		}
		else if (tp==-1) { if (max>min) Net.out[0][pat]=0.6; else Net.out[0][pat]=0.4; }

		//      
		name="cur"+ITS(pat);
		if (Net.out[0][pat]>=0.6) 
		{ 
			aout[pat].Create(0, name, 0, rates[pat].time, rates[pat].open); 
			if (Net.out[0][pat]==0.6) aout[pat].ArrowCode(241); 
			else if (Net.out[0][pat]==0.75) aout[pat].ArrowCode(225); 
			else aout[pat].ArrowCode(233); aout[pat].Color(ForestGreen); 
		}
		else if (Net.out[0][pat]<=0.4) 
		{
			aout[pat].Create(0, name, 0, rates[pat].time, rates[pat].open); 
			if (Net.out[0][pat]==0.4) aout[pat].ArrowCode(242); 
			else if (Net.out[0][pat]==0.25) aout[pat].ArrowCode(226); 
			else aout[pat].ArrowCode(234); aout[pat].Color(Crimson); 
		}
		else if (Net.out[0][pat]==0.5) 
		{ 
			aout[pat].Create(0, name, 0, rates[pat].time, (rates[pat].high+rates[pat].low)/2); 
			aout[pat].ArrowCode(119); aout[pat].Color(White); 
		}
		aout[pat].Selectable(true); aout[pat].Description(DTS(min)+"  "+DTS(max));
	}
	cPattern=0; //     
	Loop=0; //  
}
//----------------------------------------------------------------- OnDeinit
void OnDeinit() 
{	
	btnStep.Delete(); btnWalk.Delete(); 
}
//----------------------------------------------------------------- OnChartEvent
void OnChartEvent(const int id, const long &lparam, const double &dparam, const string &sparam)
{
	int n; double d;
	string st="", bs;
	if(id==CHARTEVENT_OBJECT_CLICK)
	{
		if (sparam==btnStep.Name())
		{
			Loop++;
			Net.Step(cPattern); cPattern++; //      
			if (cPattern>Net.nPattern) cPattern=0; //   ,   
			DrawOut(); //     
			btnStep.State(0);
		}
		if (sparam==btnWalk.Name())
		{
			btnWalk.Description("||");
			while(true)
			{
				Loop++;
				Net.Walk(); //     
				if (MathMod(Loop, 50)==0) DrawOut(); //   
				if (!btnWalk.State() || IsStopped()) break; //    ,  
			}
			btnWalk.Description(">>"); btnWalk.State(0);
		}
	}
	if(id==CHARTEVENT_KEYDOWN)
	{
		if(lparam==KEY_RIGHT)
		{
			btnStep.State(true);
			Loop++;
			Net.Step(cPattern); cPattern++; //      
			if (cPattern>Net.nPattern) cPattern=0; //   ,   
			DrawOut(); //     
			btnStep.State(false);
		}
	}
	ChartRedraw();
}
//----------------------------------------------------------------- DrawOut
void DrawOut() //     
{
	int i, pat; 
	double d,  k;
	string name, st="", bs;
	st=IntegerToString(Loop)+"\n";
	for(pat=0; pat<Net.nPattern; pat++) //   
	{
		for(i=0;i<Net.nNeuron[0];i++) Net.Out[0][i]=Net.in[i][pat]; //   
		for(i=0;i<Net.nNeuron[Net.nLayer];i++) Net.Out[Net.nLayer][i]=Net.out[i][pat]; //    
		Net.CalculateLayer(); //  
		d=MathAbs(Net.Out[Net.nLayer][0]-Net.Out[Net.nLayer-1][0]);
		k=d; while (k<1) k=k*10; if (k>1) k=k/10;
		aout[pat].Color(RGB(255, (1-k)*255, (1-k)*255)); //     
		if (d<=0.1) bs="  !!!!!!"; else if (d>0.1 && d<=0.3) bs="  !!!"; else if (d>0.3 && d<=0.5) bs="  !"; else if (d>0.5) bs="";
		st=st+ITS(pat)+"  "+DTS(Net.out[0][pat], 2)+" : "+DTS(Net.Out[Net.nLayer-1][0], 8)+"\n";
	}
	Comment(st);
}
//----------------------------------------------------------------- RGB
int RGB(int red_value,int green_value,int blue_value)
{
//---- check parameters
	if(red_value<0)     red_value=0;
	if(red_value>255)   red_value=255;
	if(green_value<0)   green_value=0;
	if(green_value>255) green_value=255;
	if(blue_value<0)    blue_value=0;
	if(blue_value>255)  blue_value=255;
//----
	green_value<<=8;
	blue_value<<=16;
	return(red_value+green_value+blue_value);
}
